<?php 
header("Pragma: public");
header("Expires: 0"); // set expiration time
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");

require_once("global.php");

// Using XPath Parser XML
$doc = new DOMDocument();
$doc -> load(Common::$CONFIG_PATH);
$xpath = new DOMXPath($doc);
$protocol = "BIP";
$communication = $xpath -> query("//System/BACnet/Server/Communication") -> item(0);

$BIPinterface = $communication-> getAttribute("If");
$BIPPort = $communication-> getAttribute("Port");

$elDev = $xpath -> query("//System/BACnet/Objects/Device") -> item(0);
$deviceID = ($elDev==null) ? "" : $elDev -> getElementsByTagName("ID") -> item(0) -> nodeValue;
$deviceName = ($elDev==null) ? "" : $elDev -> getElementsByTagName("Name") -> item(0) -> nodeValue;
$deviceRetry = ($elDev==null) ? "" : $elDev -> getElementsByTagName("Retry") -> item(0) -> nodeValue;
$deviceTimeout = ($elDev==null) ? "" : $elDev -> getElementsByTagName("Timeout") -> item(0) -> nodeValue;
$deviceUTCOffset = ($elDev==null) ? "" : $elDev -> getElementsByTagName("UTCOffset") -> item(0) -> nodeValue;
$location = ($elDev==null) ? "" : $elDev -> getElementsByTagName("Location") -> item(0) -> nodeValue;
$desc = ($elDev==null) ? "" : $elDev -> getElementsByTagName("Description") -> item(0) -> nodeValue;
?>

<link rel="stylesheet" type="text/css" href="../css/page.css" />
<link rel="stylesheet" type="text/css" href="../css/layout.css" />
<link rel="stylesheet" type="text/css" href="../css/container.css" />
<link rel="stylesheet" type="text/css" href="../css/resize.css" />
<link rel="stylesheet" type="text/css" href="../css/treeview.css" />
<link rel="stylesheet" type="text/css" href="../css/button.css" />
<link rel="stylesheet" type="text/css" href="../css/paginator.css" />
<link rel="stylesheet" type="text/css" href="../css/datatable.css">
<link rel="stylesheet" type="text/css" href="../css/fonts-min.css" />
<script type="text/javascript" src="../js/jquery.xml.js"></script>
<script type="text/javascript" src="../js/yahoo-dom-event.js"></script>
<script type="text/javascript" src="../js/element-min.js"></script>
<script type="text/javascript" src="../js/container-min.js"></script>
<script type="text/javascript" src="../js/resize-min.js"></script>
<script type="text/javascript" src="../js/layout-min.js"></script>
<script type="text/javascript" src="../js/connection-min.js"></script>
<script type="text/javascript" src="../js/treeview-min.js"></script>
<script type="text/javascript" src="../js/button-min.js"></script>
<script type="text/javascript" src="../js/paginator-min.js"></script>
<script type="text/javascript" src="../js/datasource-min.js"></script>
<script type="text/javascript" src="../js/datatable-min.js"></script>
<script type="text/javascript" src="../js/json-min.js"></script>
<script type="text/javascript" src="../js/main.js"></script>

<style type="text/css">
	td {
	padding-left: 0em;
	padding-right: 0em;
	}

</style>

<script type="text/javascript">
(function() {
    var Dom = YAHOO.util.Dom,
        Event = YAHOO.util.Event,
        layout = null,
        resize = null,
    	BACnetObjectDataTable = null;

    Event.onAvailable('BACnet_Panel', function() {
        var panel = new YAHOO.widget.Panel('BACnet_Panel', {
            draggable: false,
            close: false,
            //autofillheight: "body", // default value, specified here to highlight its use in the example            
            underlay: 'none',
            width: '999px',
            height: '600px',
            xy: [0, 131]
        });

        panel.renderEvent.subscribe(function() {
            Event.onAvailable('BACnet_Layout', function() {
                layout = new YAHOO.widget.Layout('BACnet_Layout', {
                    height: (panel.body.offsetHeight - 20),
                    //width: 480,
                    units: [
                         { position: 'center', body: 'BACnet_Center', gutter: '0 2 0 0' }
                    ]
                });

                layout.render();
            });
        });
       
        panel.render();
        resize = new YAHOO.util.Resize('BACnet_Panel', {
            handles: ['br'],
            autoRatio: true,
            status: false,
            minWidth: 300
        });
        resize.on('resize', function(args) {
            var panelHeight = args.height,
            padding = 20;

            //Hack to trick IE into behaving
            Dom.setStyle('BACnet_Layout', 'display', 'none');
            this.cfg.setProperty("height", panelHeight + 'px');
            layout.set('height', this.body.offsetHeight - padding);
            layout.set('width', this.body.offsetWidth - padding);
            //Hack to trick IE into behaving
            Dom.setStyle('BACnet_Layout', 'display', 'block');
            layout.resize();
 
        }, panel, true);

     	// setting the destruction's rules
		YAHOO.plugin.Dispatcher.destroyer.subscribe (function(el, config){
		    panel.destroy ();
		});     

     	// BACnet Object Type
		var BACnetObjectDataTableConf = {
            
             height: "17em",
        	 renderLoopSize: 0,
        	 initialRequest:""
        };

        var BACnetObjectTypeColumns = [           
            {key:"Type",className:"align-center"},
            {key:"Maximum", className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true, validator:YAHOO.widget.DataTable.validateNumber})},
            {key:"Instance", className:"align-center" }
        ];

        var BACnetObjectSource = new YAHOO.util.DataSource("page.files/loadobjecttype.php");
        BACnetObjectSource.connXhrMode = "queueRequests";
        BACnetObjectSource.responseType = YAHOO.util.DataSource.TYPE_JSON;
        BACnetObjectSource.responseSchema = {
            resultsList: "ObjectTypes",
            fields: ["Type", "Maximum", "Instance"]
        };
        
		BACnetObjectDataTable = new YAHOO.widget.ScrollingDataTable("BACnet_Types", BACnetObjectTypeColumns,
                BACnetObjectSource, BACnetObjectDataTableConf);

        BACnetObjectDataTable.subscribe("rowClickEvent",BACnetObjectDataTable.onEventSelectRow); 
        BACnetObjectDataTable.subscribe("cellClickEvent", BACnetObjectDataTable.onEventShowCellEditor); 
		
        return {
            oDS: BACnetObjectSource,
            oDT: BACnetObjectDataTable
        };                                                            
    });
 
	var saveData = function(e) {

		var port= Dom.get("BACnet_BIPPort").value;	
		if (!isUInt(port))
		{
			alert ("BIP port has to be integer greater then 1");
			return;
		}

		var devName = Dom.get("BACnet_DeviceName").value;
		if (devName == ""){
			alert("Device Name can't be empty");
			return;
		}
		
		var devRetry = Dom.get("BACnet_DeviceRetry").value;
		if (devRetry == ""){
			alert("Device Retry can't be empty");
			return;
		}

		if (!isUInt(devRetry))
		{
			alert("Timeout has to be integer greater then 1");
			document.getElementById("BACnet_DeviceRetry").focus();
			return;
		}
		
		var devTimeout = Dom.get("BACnet_DeviceTimeout").value;
		if (devTimeout == ""){
                        alert("Device Timeout can't be empty");
			return;
		}

		if (!isUInt(devTimeout))
		{
			alert("Timeout has to be integer greater then 1");
			document.getElementById("BACnet_DeviceTimeout").focus();
			return;
		}

		var devUTCOffset = Dom.get("BACnet_DeviceUTCOffset").value;
		if (devUTCOffset == ""){
                        alert("UTC Offset can't be empty");
			return;
		}

		if ( devUTCOffset >= 720 || devUTCOffset < -720)
		{
			alert("UTC Offset has to be a integer ");
			document.getElementById("BACnet_DeviceUTCOffset").focus();
			return;
		}
		
		if (BACnetObjectDataTable != null) {
			var result = [];
			var recordSet = BACnetObjectDataTable.getRecordSet();
	
			for (var i=0; i < recordSet.getLength(); i++) {
				result.push(BACnetObjectDataTable.getRecord(i).getData());
			}

			var jsonData = YAHOO.lang.JSON.stringify(result);
			var data = Dom.get("BACnet_Data");
			data.value = jsonData;
		}
		
		var url = "page.files/bacnetsaving.php";
		var callback = {
			success: function(o){
			
				var oData = YAHOO.lang.JSON.parse(o.responseText);

				if (oData.errCode == 0){		
					Dom.get("BACnet_Save").firstChild.firstChild.disabled  =  false;
					Dom.get("BACnet_Save").firstChild.firstChild.blur();
					BACnetObjectDataTable.getDataSource().sendRequest("",BACnetObjectDataTable.onDataReturnInitializeTable,BACnetObjectDataTable);
										
				}else{
					alert(oData.errText);
				}
			},
			failure: function(o){
				alert("failure:\r\n" + o.responseText);
			}
		};

		var form = Dom.get("Bacnet");
		Dom.get("BACnet_Save").firstChild.firstChild.disabled  =  true;
		YAHOO.util.Connect.setForm(form);
		YAHOO.util.Connect.asyncRequest("POST", url, callback, null); 

    };

    var btnSave = new YAHOO.widget.Button("BACnet_Save");
    btnSave.on("click", saveData);
    var reboot = function(e) {
    	document.getElementById("BACnet_Reboot").disabled = true;
    	//Reboot_bacnet
    	var url="page.files/systemreboot.php";
    	YAHOO.util.Connect.asyncRequest("POST", url, null, null); 
    };
    var btnSaveReboot = new YAHOO.widget.Button("BACnet_Reboot");
    btnSaveReboot.on("click", reboot); 
   
})();
</script>
<div id="BACnet_Panel" class="yui-navset">
<div class="bd">
<div id="BACnet_Layout" class="yui-navset">
<div id="BACnet_Center">
<form id="Bacnet" name="Bacnet">
  <fieldset>
  <legend>Bacnet</legend>
  <label><br />
  Protocol: <strong>BACnet/IP&nbsp;&nbsp;&nbsp;</strong></label>
  <label>Port&nbsp;
		  <input id="BACnet_BIPPort" name="BACnet_BIPPort" type="text" value="<?php echo $BIPPort?>" />
  </label>
  <br />
  <br />
  <fieldset>
    <legend>Device</legend>
    <label>ID
	<input id="BACnet_DeviceID" name="BACnet_DeviceID" type="text" value="<?php echo $deviceID?>" size="10" />
    </label>
    &nbsp;
    <label>Name
	<input id="BACnet_DeviceName" name="BACnet_DeviceName" type="text" value="<?php echo $deviceName?>" />
	&nbsp;
	<label>Retry
	<input id="BACnet_DeviceRetry" name="BACnet_DeviceRetry" type="text" size="8" value="<?php echo $deviceRetry?>" />
	&nbsp;
    <label>Timeout
	<input id="BACnet_DeviceTimeout" name="BACnet_DeviceTimeout" type="text" size="8" value="<?php echo $deviceTimeout?>" />
	&nbsp;
    <label>UTC_Offset
	<input id="BACnet_DeviceUTCOffset" name="BACnet_DeviceUTCOffset" type="text" size="8" value="<?php echo $deviceUTCOffset?>" />
	<br /><br />
    <label>Location
	<input id="BACnet_Location" name="BACnet_Location" type="text" value="<?php echo $location?>" />
	&nbsp;
    <label>Decscription
	<input id="BACnet_Description" name="BACnet_Description" type="text" value="<?php echo $desc?>" size="64"/>
	</label>
  </fieldset>
  <br />
  <fieldset>
  <legend>Types</legend>
<br />
<div id="BACnet_Types"></div>
  </fieldset>
  <br />
  <input id="BACnet_Data" name="BACnet_Data" type="hidden" value="" />
  <input id="BACnet_Save" name="BACnet_Save" type="button" value="Save" /> 
  <input id="BACnet_Reboot" name="BACnet_Reboot" type="button" value="Reboot"/> 
  </fieldset>
</form>
</div>
</div>
</div>
