<?php
require_once("global.php");

header("Content-Type:application/json");

$errCode = 0;
$errText = "";

$protocol = "BIP";

$deviceId = $_REQUEST["BACnet_DeviceID"];
$deviceName = $_REQUEST["BACnet_DeviceName"];
$deviceRetry = $_REQUEST["BACnet_DeviceRetry"];
$deviceTimeout = $_REQUEST["BACnet_DeviceTimeout"];
$deviceUTCOffset = $_REQUEST["BACnet_DeviceUTCOffset"];
$location = $_REQUEST["BACnet_Location"];
$desc = $_REQUEST["BACnet_Description"];
$jsonData = $_REQUEST["BACnet_Data"];
$arr = (array) json_decode(stripslashes($jsonData));


$doc = new DOMDocument("1.0", "utf-8");
$doc -> load(Common::$CONFIG_PATH);
$doc -> formatOutput = true;
$doc -> preserveWhitespace = false;

$xpath = new DOMXPath($doc);

// Protocol
$elProtocol= $xpath -> query("//System/BACnet/Server/Protocol") -> item(0);
$elProtocol -> nodeValue = $protocol;

$elCommunication = $xpath -> query("//System/BACnet/Server/Communication") -> item(0);

// Communication
if ($protocol=="BIP")
{
	$if =  "eth0";
	$port =  $_REQUEST["BACnet_BIPPort"];
	
	$elCommunication->setAttribute( "If" , $if);
	$elCommunication->setAttribute( "Port" , $port);
}else if($protocol=="MSTP"){
	$port =  $_REQUEST["BACnet_MSTPPort"];
	$elCommunication->setAttribute( "Port" , $port);
	$frame =  $_REQUEST["BACnet_MSTPFrame"];
	$elCommunication->setAttribute( "Frame" , $frame);
	$max =  $_REQUEST["BACnet_MSTPMax"];
	$elCommunication->setAttribute( "Max" , $max);
	$mac =  $_REQUEST["BACnet_MSTPMac"];
	$elCommunication->setAttribute( "Mac" , $mac);
}

// Device
$elDeviceID = $xpath -> query("//System/BACnet/Objects/Device/ID") -> item(0);
$elDeviceID -> nodeValue = $deviceId;

$elDeviceName = $xpath -> query("//System/BACnet/Objects/Device/Name") -> item(0);
$elDeviceName -> nodeValue = $deviceName;

$elDeviceRetry = $xpath -> query("//System/BACnet/Objects/Device/Retry") -> item(0);
$elDeviceRetry -> nodeValue = $deviceRetry;

$elDeviceTimeout = $xpath -> query("//System/BACnet/Objects/Device/Timeout") -> item(0);
$elDeviceTimeout -> nodeValue = $deviceTimeout;

$elDeviceUTCOffset = $xpath -> query("//System/BACnet/Objects/Device/UTCOffset") -> item(0);
$elDeviceUTCOffset -> nodeValue = $deviceUTCOffset;

$elLoc = $xpath -> query("//System/BACnet/Objects/Device/Location") -> item(0);
$elLoc -> nodeValue = $location;

$elDesc = $xpath -> query("//System/BACnet/Objects/Device/Description") -> item(0);
$elDesc -> nodeValue = $desc;


// ObjectType Mapping
$elObj = $xpath -> query("//System/BACnet/Objects") -> item(0);
$typeList = $xpath -> query("//System/BACnet/Objects/*[not(name()='Device')]");
foreach($typeList as $oldType){
	$elObj -> removeChild($oldType);
}

$elObjTypes = $xpath -> query("//System/BACnet/Server/ObjectTypes") -> item(0);
$objTypeList = $xpath -> query("//System/BACnet/Server/ObjectTypes/*");
foreach($objTypeList as $oldObjType){
	$elObjTypes -> removeChild($oldObjType);
}

$cnt=0;
foreach ($arr as $data) {

	$data = (array) $data;
	$typeName = $data["Type"];
	$maximum = $data["Maximum"];
	$instance = $data["Instance"];

	$nodeType = $doc -> createElement($typeName);
	$elObj -> appendChild($nodeType);
		
	$nodeMaximum = $doc -> createElement("Maximum");
	$nodeMaximum -> nodeValue = $maximum;
	$nodeType -> appendChild($nodeMaximum);
	
	$nodeInstance = $doc -> createElement("InstanceNumber");
	$nodeInstance -> nodeValue = $instance;
	$nodeType -> appendChild($nodeInstance);
	
	$nodeObjType = $doc -> createElement("Type");
	$nodeObjType -> nodeValue = $typeName;
	$elObjTypes -> appendChild($nodeObjType);

	$cnt++;
}

$elObjTypes -> setAttribute("Number", $cnt);

//$doc -> save(Common::$CONFIG_PATH);

$xml = formatXmlString($doc -> saveXML());

$h = fopen(Common::$CONFIG_PATH, 'w');
fwrite($h, $xml);
fclose($h);

$url = "main.php?Page=bacnet";
$result = array("errCode" => $errCode, "errText" => $errText, "url" => $url);	
echo json_encode($result);
?>
