<?php
require_once("global.php");

header("Pragma: public");
header("Expires: 0"); // set expiration time
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");
header("Content-Type:text/xml");

// Using XPath Parser XML
$doc = new DOMDocument();
$doc -> load(Common::$CONFIG_PATH);

$xpath = new DOMXPath($doc);
$query = "//System/Modbus/Devices/Device";
$deviceList = $xpath -> query($query);

$newDoc = new DOMDocument("1.0", "utf-8");
$newDoc -> formatOutput = true;
$root = $newDoc -> createElement("DeviceList");
$newDoc -> appendChild($root);

foreach ($deviceList as $device)
{
	
	$devNode= $newDoc -> createElement("Device");
	$ID = $device -> getAttribute("ID");
	$type = $device -> getAttribute("Type");
	
	$devNode -> setAttribute("ID", $ID);
	$devNode -> setAttribute("Type", $type);
	if (strcmp($type,'RTU')==0)
	{
		$port = $device -> getAttribute("Port");
		$deviceID = $device -> getAttribute("DeviceID");
		
		$devNode -> setAttribute("Port", $port);
		$devNode -> setAttribute("DeviceID", $deviceID);
	}else
	{
		$address = $device -> getAttribute("Address");
		$port = $device -> getAttribute("Port");
		$unit = $device -> getAttribute("Unit");
		
		$devNode -> setAttribute("Address", $address);
		$devNode -> setAttribute("Port", $port);
		$devNode -> setAttribute("Unit", $unit);
	}
	
	
	$pointList = $xpath -> query("Points/Point", $device);
	foreach($pointList as $point)
	{
		
		$pointID = $point -> getAttribute("ID");

		$pointNode = $newDoc -> createElement("Point");
		$pointNode -> setAttribute("ID", $pointID);
		$devNode -> appendChild($pointNode);
	}

	$root -> appendChild($devNode);
}

echo $newDoc -> saveXML();

?>

