<?php 
session_start();
header("Pragma: public");
header("Expires: 0"); // set expiration time
header("Cache-Control: must-revalidate, post-check=0, pre-check=0");

require_once("global.php");
$ID = $_REQUEST["ID"];

// Using XPath Parser XML
$doc = new DOMDocument();
$doc -> load(Common::$CONFIG_PATH);

$xpath = new DOMXPath($doc);
$query = "//System/Modbus/Devices/Device[@ID='".$ID."']";

$nodeList = $xpath -> query($query);
$deviceelement = null;
$portElement = null;

$deviceID="";
$portType="RTU";
$portMode="RS485";
$RTUPortName="COM1";

$tcpAddress="";
$tcpPort="502";
$tcpUnit="0";

if(strcmp($_SESSION["device"],'GW5492')==0)
{
	$portType="RTU";
    //echo "<script>alert(\"RTU\");</script>";
}
else
{
	$portType="TCP";
}

if ($nodeList-> length >= 1)
{
	$deviceelement = $nodeList -> item(0);
	if (strcmp($portType,'RTU')==0)
	{
		$RTUPortName = $deviceelement-> getAttribute("Port");
		$deviceID = $deviceelement-> getAttribute("DeviceID");
	}else
	{
		$tcpAddress = $deviceelement-> getAttribute("Address");
		$tcpPort =  $deviceelement-> getAttribute("Port");
		$tcpUnit =  $deviceelement-> getAttribute("Unit");
	}
}
?>
<!-- link rel="stylesheet" type="text/css" href="../css/reset-font.css" /-->
<link rel="stylesheet" type="text/css" href="../css/page.css" />
<link rel="stylesheet" type="text/css" href="../css/layout.css" />
<link rel="stylesheet" type="text/css" href="../css/container.css" />
<link rel="stylesheet" type="text/css" href="../css/resize.css" />
<link rel="stylesheet" type="text/css" href="../css/treeview.css" />
<link rel="stylesheet" type="text/css" href="../css/button.css" />
<link rel="stylesheet" type="text/css" href="../css/paginator.css" />
<link rel="stylesheet" type="text/css" href="../css/datatable.css">
<link rel="stylesheet" type="text/css" href="../css/fonts-min.css" />
<script type="text/javascript" src="../js/jquery.xml.js"></script>
<script type="text/javascript" src="../js/yahoo-dom-event.js"></script>
<script type="text/javascript" src="../js/element-min.js"></script>
<script type="text/javascript" src="../js/container-min.js"></script>
<script type="text/javascript" src="../js/resize-min.js"></script>
<script type="text/javascript" src="../js/layout-min.js"></script>
<script type="text/javascript" src="../js/connection-min.js"></script>
<script type="text/javascript" src="../js/treeview-min.js"></script>
<script type="text/javascript" src="../js/button-min.js"></script>
<script type="text/javascript" src="../js/paginator-min.js"></script>
<script type="text/javascript" src="../js/datasource-min.js"></script>
<script type="text/javascript" src="../js/datatable-min.js"></script>
<script type="text/javascript" src="../js/json-min.js"></script>
<script type="text/javascript" src="../js/main.js"></script>

<script type="text/javascript">
function ModbusOnChangePortType(str)
{
	if(str == "TCP")
	{
		alert("In TCP");
		document.getElementById("ModbusCommunication").innerHTML=
		 	"Address"+
		    "<input id='TCPAddress' name='TCPAddress' type='text' value='<?php  echo($tcpAddress)?>'/>"+
		    "&nbsp;"+
		    "<label>Port"+
		  	  "<input id='TCPPort' name='TCPPort' type='text' value='<?php  echo($tcpPort)?>'/>"+
		    "</label>"+
		    "&nbsp;"+
		    "<label>Unit"+
		    	"<input id='TCPUnit' name='TCPUnit' type='text' value='<?php  echo($tcpUnit)?>'/>"+
		    "</label>";	  
	}else if(str == "RTU")
	{
		alert("In RTU");
		document.getElementById("ModbusCommunication").innerHTML=
			"COM Port"+
	        "<select name='RTUPort' id='RTUPort'>"+
		        "<option value='COM1' <?php echo (strcmp($RTUPortName,'COM1')==0) ? 'selected':''?>>COM1</option>"+
		        "<option value='COM2' <?php echo (strcmp($RTUPortName,'COM2')==0) ? 'selected':'' ?>>COM2</option>"+
	        "</select>"+
	        "&nbsp;"+
			"<label>DeviceID"+
			  	"<input type='text' id='DeviceID' name='DeviceID' value='<?php echo $deviceID ?>'/>"+
			"</label>";
	}
}
</script>

<script type="text/javascript">
(function() {
    var Dom = YAHOO.util.Dom,
        Event = YAHOO.util.Event,
        layout = null,
        resize = null,
        tree = null,
    	myDataTable = null;

	var callback = {
		success: function(o){

			var xmlDoc = o.responseXML;
			var nodeList = xmlDoc.selectNodes("/DeviceList/Device");

			// Generate Tree
			tree = new YAHOO.widget.TreeView("tree");
			var treeRoot = tree.getRoot();

			var deviceNode = new YAHOO.widget.TextNode('Devices', treeRoot, true);
			deviceNode.labelElId = "";
								
			for (var i=0; i < nodeList.length; i++) 
			{
				var id = nodeList[i].getAttribute("ID");
				var type = nodeList[i].getAttribute("Type");
				if(type == "RTU")
				{
					var port = nodeList[i].getAttribute("Port");
					var deviceID = nodeList[i].getAttribute("DeviceID");
					var tempNode = new YAHOO.widget.TextNode(id, deviceNode, true);
					tempNode.labelElId = id;
					tempNode.data = {"item":[{"Port": port, "DeviceID": deviceID}]};
				}else
				{
					var address = nodeList[i].getAttribute("Address");
					var port = nodeList[i].getAttribute("Port");
					var unit = nodeList[i].getAttribute("Unit");
					var tempNode = new YAHOO.widget.TextNode(id, deviceNode, true);
					tempNode.labelElId = id;
					tempNode.data = {"item":[{"Address": address, "Port": port, "Unit":unit}]};
				}
			}
			
	        tree.render();

			<?php if (strcmp($ID,'')==0) 
			{ ?>
				deviceNode.focus();
			<?php 
			}else{ ?>

	        var children = deviceNode.children;

	        for (var j=0; j < children.length; j++) {
		        var node = children[j];
				if ( node.labelElId == '<?php echo $ID?>' ) {				
					node.focus();
				}
		    }
		    <?php } ?>

	        tree.subscribe('clickEvent',function(oArgs) { 
		         var link = "main.php?Page=modbus";
		    	 if ( !YAHOO.lang.isNull(oArgs.node.labelElId) && oArgs.node.labelElId != '' ) {
	    		 	link += "&ID=" + oArgs.node.labelElId;
		    	 }
		    	 location.href = link;
	    	}); 
	    },
		failure: function(o){
		}
	};

	var request = YAHOO.util.Connect.asyncRequest("POST", "page.files/loadtreenodes.php", callback, "");  

    Event.onAvailable('panel', function() {
        var panel = new YAHOO.widget.Panel('panel', {
            draggable: false,
            close: false,
            //autofillheight: "body", // default value, specified here to highlight its use in the example            
            underlay: 'none',
            width: '999px',
            height: '630px',
            xy: [0, 131]
        });

        panel.renderEvent.subscribe(function() {
            Event.onAvailable('layout', function() {
                layout = new YAHOO.widget.Layout('layout', {
                    height: (panel.body.offsetHeight - 20),
                    //width: 480,
                    units: [
                        { position: 'left', width: 150, resize: true, body: 'left', gutter: '0 5 0 2', minWidth: 150, maxWidth: 300 },
                        { position: 'center', body: 'center', gutter: '0 2 0 0' }
                    ]
                });

                layout.render();
            });
        });
        panel.render();
        resize = new YAHOO.util.Resize('panel', {
            handles: ['br'],
            autoRatio: true,
            status: false,
            minWidth: 300
        });
        resize.on('resize', function(args) {
            var panelHeight = args.height,
            padding = 20;
            //Hack to trick IE into behaving
            Dom.setStyle('layout', 'display', 'none');
            this.cfg.setProperty("height", panelHeight + 'px');
            layout.set('height', this.body.offsetHeight - padding);
            layout.set('width', this.body.offsetWidth - padding);
            //Hack to trick IE into behaving
            Dom.setStyle('layout', 'display', 'block');
            layout.resize();
            
        }, panel, true);

     	// setting the destruction's rules
		YAHOO.plugin.Dispatcher.destroyer.subscribe (function(el, config){
		    panel.destroy ();
		});     
		
		<?php 	
			if (strcmp($ID,'') != 0) {
				include_once("point.php");
			}
		?>                                                                           
    });

	<?php if (strcmp($ID,'') != 0) {?>
	var handleClick = function(e){
		if (window.confirm("Are you sure to remove selected device?")){
			var url =  'page.files/modbusdeleting.php?ID=<?php echo $ID?>';

			var callback = {
				success: function(o){
					var oData = YAHOO.lang.JSON.parse(o.responseText);

					if (oData.errCode == 0){		

						location.href = oData.url;
						<?php include_once("signalAsyncCallback.php")?>
								
					}else{
						alert(oData.errText);
					}
				},
				failure: function(o){
					alert("failure:\r\n" + o.responseText);
				}
			};

			YAHOO.util.Connect.asyncRequest("POST", url, callback, null); 
        }
    };
    
	var btnDel = new YAHOO.widget.Button("Del");
	btnDel.on("click", handleClick);
	<?php }?>

	var saveData = function(e) {
		var target = Event.getTarget(e);

		var isReboot = false;
		if (target.id == "SaveReboot-button"){
			isReboot = true;
		}
		var ID = Dom.get("ID").value;
		var errText = "";

		if (ID == "")
		{
			errText += "ID can't be empty!\r\n";
		}
		var protocol = Dom.get("ModbusType").value;

		if (protocol == "TCP"){

			var addr = Dom.get("TCPAddress").value;
			
			if ( addr == ""){
				errText += "Address can't be empty!\r\n";
			}else{
				if (!ipValidator(addr)){
					errText += "Address is wrong format!\r\n";
				}
			}

			var port = Dom.get("TCPPort").value;
			if (port == ""){
				errText += "TCP Port can't be empty!\r\n";
			}else{
				if (!portValidator(port)){
					errText += "TCP Port is wrong format!\r\n";
				}
			}

			var unit = Dom.get("TCPUnit").value;
			if (unit == ""){
				errText += "TCP Unit can't be empty!\r\n";
			}else{
				if (unit!="0" && !isUInt(unit)){
					errText += "TCP Unit is wrong format!\r\n";
				}
			}

			var nodeCount = tree.getNodeCount();
			
			if ( nodeCount+1 >= 30)
			{
				errText += "Total Devices limit is  " + nodeCount + "\r\n";
				}
				
			for(var i=1; i <= nodeCount; i++){
				var node = tree.getNodeByIndex(i);
				if (node.depth != 1){
					continue;
				}

				if (node.labelElId == ID){
					continue;
				}

				oData = node.data.item[0];

				//if (port == oData.Port){
					//errText += "The Port '" + port + "' is used on device '" + node.labelElId  +"'!\r\n";
					//break;
				//}
			}		
		}else if (protocol == "RTU")
		{
			if (Dom.get("DeviceID").value == ""){
				errText += "Device ID can't be empty!\r\n";
			}
			
			var nodeCount = tree.getNodeCount();
			if ( nodeCount+1 >= 30)
			{
				errText += "Total Devices limit is  " + nodeCount + "\r\n";
				}
		}
		if (errText != ""){
			alert(errText);
			return;
		}
		if (myDataTable != null) {
			var result = [];
			var recordSet = myDataTable.getRecordSet();
	
			for (var i=0; i < recordSet.getLength(); i++) {
				// check GUI
				var tempvalue =myDataTable.getRecord(i).getData("Address");
				
				if ( tempvalue == "")
				{
					alert("Please input address for PointID "+myDataTable.getRecord(i).getData("ID"));
					return;
				}

				
				result.push(myDataTable.getRecord(i).getData());
			}
	
			var jsonData = YAHOO.lang.JSON.stringify(result);
			var data = Dom.get("Data");
			data.value = jsonData;
		}
		var saveType = Dom.get("SaveType");	

		if (saveType.value == 'A')
		{		

			var nodeCount = tree.getNodeCount();			
			
			for(var i=1; i <= nodeCount; i++){
				var node = tree.getNodeByIndex(i);

				if (ID == node.labelElId){
					alert("Duplicate ID:" + ID + "!");
					return;
				}
			}
		}
		
		var url = "page.files/modbussaving.php";
		
		var callback = 
		{
			success: function(o){

				var oData = YAHOO.lang.JSON.parse(o.responseText);

				if (oData.errCode == 0){		
					location.href = oData.url;

					if (isReboot == true){
						Modbushttp=GetXmlHttpObject();
						var url="page.files/systemreboot.php";
						Modbushttp.open("GET",url,true);
						document.getElementById("SaveReboot").disabled = true;
						Modbushttp.send(null);
					}
						
				}else{
					alert(oData.errText);
				}
			},
			failure: function(o){
				alert("failure:\r\n" + o.responseText);
			}
		};

		var form = Dom.get("Modbus");
		YAHOO.util.Connect.setForm(form);
		YAHOO.util.Connect.asyncRequest("POST", url, callback, null); 

    };

    var btnSave = new YAHOO.widget.Button("ModbusSave");
    btnSave.on("click", saveData);

    var reboot = function(e) {
    	document.getElementById("Reboot_Modbus").disabled = true;
    	var url="./page.files/systemreboot.php";
    	YAHOO.util.Connect.asyncRequest("POST", url, null, null); 
    };
    var btnSaveReboot = new YAHOO.widget.Button("Reboot_Modbus");
    btnSaveReboot.on("click", reboot); 
    
})();
</script>

<div id="panel" class="yui-navset">
<?php if(strcmp($_SESSION["device"],'BNET5304')==0 or strcmp($_SESSION["device"],'BNET5310')==0) {?>
<br>The Interface is only available for Gateway Devices....</br>
<?php } else {?>
	<div class="bd">
		<div id="layout" class="yui-navset">
			<div id="left">
				<div id="tree" class="yui-navset"></div>
			</div>
			<div id="center">
			<form id="Modbus" name="Modbus">
			  <fieldset>
			  <legend>Modbus</legend>
			  <label>ID
			  <input type="text" id="ID" name="ID" value="<?php echo $ID ?>" <?php echo (strcmp($ID,'')==0) ? "" :  "readonly=\"readonly\"" ?>/>
			  </label>
              <label>Type
			  <input name="ModbusType" type="text" disabled id="ModbusType" value= "<?php echo $portType ?>" size="7">
			  </label>
			  <br/>
			  <br/>
				<fieldset>
			    <legend>Communication</legend>
			  <div id="ModbusCommunication">
				  <?php
				  printf($portType);  
				  if (strcmp($portType,'TCP')==0)
				  {?>
					<label>
					    Address
					    <input id="TCPAddress" name="TCPAddress" type="text" value="<?php echo $tcpAddress ?>"/>
					</label>
					    &nbsp;
					<label>Port
					    <input id="TCPPort" name="TCPPort" type="text" value="<?php echo $tcpPort ?>"/>
					</label>
					    &nbsp;
					<label>Unit
					    <input id="TCPUnit" name="TCPUnit" type="text" value="<?php echo $tcpUnit ?>"/>
				    </label>
				  <?php
				  }else  if (strcmp($portType,'RTU')==0)
				  {?>
					  <label>
					      COM Port
					      <select name="RTUPort" id="RTUPort">
					        <option value="COM1">COM2</option>
					        <option value="COM2">COM3</option>
				      </select>
				      </label>
				      	&nbsp;
				      <label>DeviceID
					  		<input type="text" id="DeviceID" name="DeviceID" value="<?php echo $deviceID ?>"/>
					  </label>
				 <?php 
				  }?>
			 </div>
			 </fieldset>
			  <br />
			  <br />
			  <?php if (strcmp($ID,'') != 0) {?>
			  <fieldset>
				  <legend>Point</legend>
				  <input id="PointID" name="PointID" type="text" size="16"/>
				  <input type="button" id="Add_Point" name="Add_Point" value="Add" />
				 　<br />
				　<div id="datatable"></div>
			  </fieldset>
				  <?php }?>
				  <br/>
				  <input id="Data" name="Data" type="hidden" value="" />
				  <input id="SaveType" name="SaveType" type="hidden" value="<?php echo (strcmp($ID,'')==0) ?  "A" : "M" ?>" />
				  <input id="ModbusSave" name="ModbusSave" type="button" value="Save" /> 
				  <?php if (strcmp($ID,'') != 0) {?>
				  <input id="Del" name="Del" type="button" value="Delete" /> 
				  <?php }?>
			  </fieldset>
			</form>
			</div>
		</div>
	</div>
<?php }?>
</div>