<?php
session_start();
require_once("global.php");

header("Content-Type:application/json");

$errCode = 0;
$errText = "";

$ID = $_REQUEST["ID"];
$deviceId="";
$devicename = $_SESSION["device"];
$type = "";
$TCPAddress = "";
$TCPPort = "";
$TCPUnit = "";
$RTUPort = "";

if(strcmp($_SESSION["device"], 'GW5492')==0)
{
	$type = "RTU";
}
else
{
	$type = "TCP";
}
if (strcmp($type,'TCP')==0)
{
	$TCPAddress = $_REQUEST["TCPAddress"];
	$TCPPort = $_REQUEST["TCPPort"];
	$TCPUnit = $_REQUEST["TCPUnit"];
}else
{
	$deviceId = $_REQUEST["DeviceID"];
	$RTUPort = $_REQUEST["RTUPort"];
}
$jsonData = $_REQUEST["Data"];
$arr = (array) json_decode(stripslashes($jsonData));


$doc = new DOMDocument("1.0", "utf-8");
$doc -> load(Common::$CONFIG_PATH);
$doc -> formatOutput = true;
$doc -> preserveWhitespace = false;

$xpath = new DOMXPath($doc);
$query = "//System/Modbus/Devices/Device[@ID='" .$ID ."']";

$nodeList = $xpath -> query($query);
$deviceelement = NULL;
if ($nodeList-> length >= 1)
{
	$deviceelement = $nodeList -> item(0);
	$deviceelement->parentNode->removeChild($deviceelement);
}
	
$deviceelement = $doc -> createElement("Device");
$query = "//System/Modbus/Devices";
$nodeList = $xpath -> query($query);
$nodeList -> item(0)->appendChild($deviceelement);

$deviceelement -> setAttribute("ID", $ID);
$deviceelement -> setAttribute("Type", $type);
if (strcmp($type,'RTU')==0)
{
	$deviceelement -> setAttribute("Port", $RTUPort);
	$deviceelement -> setAttribute("DeviceID", $deviceId);
}else
{
	$deviceelement -> setAttribute("Address", $TCPAddress);
	$deviceelement -> setAttribute("Port", $TCPPort);
	$deviceelement -> setAttribute("Unit", $TCPUnit);
}
$elPointList  = $doc -> createElement("Points");
$deviceelement-> appendChild($elPointList);

// Compose New Point List
if ($arr != null){
	
	$i=1;
	foreach ($arr as $data) {

		$data = (array) $data;
		$type = $data["Type"];
		$write = "FALSE";
		$BACnetType = "ANALOGOUTPUT";
		
		$readType = "Read " .$type;
		$writeType = "Write " .$type;
		
		if (strcmp($data["Write"],"Write")==0){
			$write = "TRUE";
		}
		
		$timeOut = ($data["TimeOut"]<=0) ? 3 : $data["TimeOut"];
		$sampling = ($data["Sampling"]<=0) ? 10 : $data["Sampling"];
		
		$elPoint = $doc -> createElement("Point");
		$elPoint -> setAttribute("ID", $data["ID"]);
		$elPoint -> setAttribute("Address", $data["Address"]);
		$elPoint -> setAttribute("Count", $data["Count"]);
		$elPoint -> setAttribute("TypeDef", $data["TypeDef"]);
		$elPoint -> setAttribute("Sampling", $sampling);
		$elPoint -> setAttribute("TimeOut", $timeOut);
		$elPoint -> setAttribute("ScaleFactor", $data["ScaleFactor"]);
		$elPoint -> setAttribute("Intercept", $data["Intercept"]);
		$elPoint -> setAttribute("Low", $data["Low"]);
		$elPoint -> setAttribute("Hi", $data["Hi"]);
		$elPoint -> setAttribute("Write", $write);
		$elPoint -> setAttribute("Type", $type);
		$elPoint -> setAttribute("Description", $BACnetType);

		$elPointList -> appendChild($elPoint);
		++$i;
	}
}
$query = "//System/BACnetModbusMapping/Item [@Device='" .$ID ."']";

$nodeList = $xpath -> query($query);

for($i = $nodeList->length ;$i>0;--$i)
{
	$mapNode = $nodeList->item($i-1);
	$pointID = $mapNode-> getAttribute("Point");
	$query = "//System/Modbus/Devices/Device [@ID='" .$ID ."']/Points/Point [@ID='" .$pointID ."']";
	$tmpList = $xpath -> query($query);
	
	if ($tmpList->length == 0)
	{
		$mapNode->parentNode->removeChild($mapNode);
	}
}

$doc -> normalizeDocument();

$xml = formatXmlString($doc -> saveXML());

$h = fopen(Common::$CONFIG_PATH, 'w');
fwrite($h, $xml);
fclose($h);

$url = "main.php?Page=modbus&ID=" .$ID; 
$result = array("errCode" => $errCode, "errText" => $errText, "url" => $url);	
echo json_encode($result);

?>
