		
		var lowHiValidator = function(oData){

			if (oData === undefined){
				return oData;
			}

			if (oData != "" && !isFloat(oData)){
				oData = "";
			}
			
			return oData;
		};
		
        var myConfig = {
             width: "57em",
             height: "15em",
        	 renderLoopSize: 100
        };

        var myColumnDefs = [
        	{key:"ID", className:"align-center"},
            {key:"Address", label:"Address", className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true})},
            {key:"Count", className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true, validator:YAHOO.widget.DataTable.validateNumber})},
            {key:"Type", className:"align-center", editor: new YAHOO.widget.DropdownCellEditor({dropdownOptions:["DISCRETE INPUT","COIL","INPUT REGISTER","HOLDING REGISTER"],disableBtns:true}) },
           // {key:"Description", label:"Description", className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true})},
            {key:"TypeDef", label:"Type Define", className:"align-center", editor: new YAHOO.widget.DropdownCellEditor({dropdownOptions:["BIT", "CHAR","UCHAR","INT16","UINT16","INT32","UINT32","FLOAT32","DOUBLE32"],disableBtns:true})},
            {key:"Sampling", label:"Sampling(ms)",className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true, validator:YAHOO.widget.DataTable.validateNumber})},
            {key:"TimeOut", label:"TimeOut(ms)",className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true, validator:YAHOO.widget.DataTable.validateNumber})},
            {key:"ScaleFactor", className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true, validator:YAHOO.widget.DataTable.validateNumber})},
            {key:"Intercept", className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true, validator:YAHOO.widget.DataTable.validateNumber, defaultValue: 0})},
            {key:"Low", className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true, validator: lowHiValidator})},
            {key:"Hi", className:"align-center", editor: new YAHOO.widget.TextboxCellEditor({disableBtns:true, validator: lowHiValidator})},
          	{key:"Write", label:"Read/Write", className:"align-center", editor: new YAHOO.widget.DropdownCellEditor({dropdownOptions:["Write","Read"],disableBtns:true})},
            {key:"Del", className:"align-center", formatter: formatBtnDel}
        ];
               
		var dataSourceUrl = "page.files/loadpoint.php?ID=<?php echo $ID ?>";
        var myDataSource = new YAHOO.util.DataSource(dataSourceUrl);
        myDataSource.connMethodPost = true;
        myDataSource.responseType = YAHOO.util.DataSource.TYPE_XML;
        myDataSource.responseSchema = {
            resultNode: "Point",
            fields: ["ID","Address",{key:"Count", parser:"number"},"Type","Description","TypeDef",{key:"Sampling", parser:"number"},{key:"TimeOut", parser:"number"},{key:"ScaleFactor", parser:"number"},
            		 {key:"Intercept", parser:"number"},{key:"Low", parser:"number"},{key:"Hi", parser:"number"},"Write"
            		]
        };
        
		var container = "datatable";
		myDataTable = new YAHOO.widget.ScrollingDataTable(container, myColumnDefs,
                myDataSource, myConfig);

     	// Set up editing flow
        var highlightEditableCell = function(oArgs) {
            var elCell = oArgs.target;
            if(YAHOO.util.Dom.hasClass(elCell, "yui-dt-editable")) {
                myDataTable.highlightCell(elCell);
            }
        };

        // Cell Button Click Event
        var cellButtonClick = function(oArgs) {
        	var oRecord = myDataTable.getRecord(oArgs.target);
            if (window.confirm("確定要刪除此列?")){
            	myDataTable.deleteRow(oRecord);
            }
        };
        
        
        // Cell Update Event
        var cellUpdate = function(oArgs) {
        	var field = oArgs.column.key;
        	var data = oArgs.record.getData(field);
        	var isMod = false;

	        switch(field){
	        	case "Sampling":
	        		if ( data <= 0 ) {
	        			data = 10;
	        			isMod = true;
	        		}
	        		break;
	        		
	        	case "TimeOut":
	        	
        			if ( data <= 0 ) {
	        			data = 7;
	        			isMod = true;
	        		}
	        		break;
	        		
	           case "Count":
	        	
        			if ( data <= 0  ) {
	        			data = 1;
	        			isMod = true;
	        		}
	        		else if ( data > 64  )
	        		{
	        			data = 64;
	        			isMod = true;
	        		}
	        		break;
	        	
	        	default:
	        		break;
	        }
	
			if (isMod == true){
				myDataTable.updateCell(oArgs.record, field, data);
			}
        };
        
        myDataTable.subscribe("cellMouseoverEvent", highlightEditableCell);
        myDataTable.subscribe("cellMouseoutEvent", myDataTable.onEventUnhighlightCell);
        myDataTable.subscribe("cellClickEvent", myDataTable.onEventShowCellEditor);
        myDataTable.subscribe("buttonClickEvent", cellButtonClick);
        myDataTable.subscribe("cellUpdateEvent", cellUpdate);
     
<!--		var getLastRecordIndex = function(){-->
<!--			var idx = myDataTable.getRecordSet().getLength();-->
<!--			return idx;-->
<!--		};-->

		var getData = function() {
			return {Address:"", Count:1, Type:"COIL", Description:"", TypeDef:"BIT", Sampling: 1000, TimeOut:7000, ScaleFactor:1, 
				Low:"", Hi:"", Intercept: 0, Write:"Write"};			         
		};

        // Add New Row Button
        var handleAddClick = function(e){
        	var tempPoint = Dom.get("PointID");
        	var recordSet = myDataTable.getRecordSet();
       		for (var i=0; i < recordSet.getLength(); i++) {
				var tempvalue =myDataTable.getRecord(i).getData("ID");
				
				if ( tempvalue == tempPoint.value)
				{
					alert("PointID "+tempPoint.value+" already exist");
					return;
				}
			}
			var data = {ID:tempPoint.value,Address:"", Count:1, Type:"COIL", TypeDef:"BIT", Sampling: 1000, TimeOut:7000, ScaleFactor:1, 
				Low:"", Hi:"", Intercept: 0, Write:"Write"};
				//, Description:""
            myDataTable.addRow(data, myDataTable.getRecordSet().getLength());
            tempPoint.value="";
        };

		var btnPointAddName = "Add_Point";
        var btnPointAdd = new YAHOO.widget.Button(btnPointAddName);
        btnPointAdd.on("click", handleAddClick);
		
        return {
            oDS: myDataSource,
            oDT: myDataTable
        };       
