<?php

function validateIpAddress($ip_addr)

{  //first of all the format of the ip address is matched  
	if(preg_match("/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/",$ip_addr))  
	{   
		//now all the intger values are separated    
		$parts=explode(".",$ip_addr);    

		//now we need to check each part can range from 0-255    
		foreach($parts as $ip_parts)    
		{      
			if(intval($ip_parts)>255 || intval($ip_parts)<0)
			      return false;
			 //if number is not within range of 0-255    
		}    
		return true;  
	}  else
	    return false; 
	    //if format of ip address doesn't matches
}


require_once("global.php");


if ($_FILES["file"]["error"] > 0)
{
    echo "File Upload Error: " . $_FILES["file"]["error"];
    return;
}
else
{	
	if(strpos($_FILES["file"]["name"], ".csv")!==false)
	{
		move_uploaded_file($_FILES["file"]["tmp_name"],Common::$TMP_PATH."/config.csv");
		
		$file=fopen(Common::$TMP_PATH."/config.csv","r");
 		if (feof($file))
  		{
			echo "Invalid file: Empty File";
			fclose($file); 
	  		return;
 		}

 		$counterAV = 0;
 		$counterAO = 0;
 		$counterAI = 0;
 		$counterBV = 0;
 		$counterBO = 0;
 		$counterBI = 0;
 		$counterMV = 0;
 		$counterMO = 0;
 		$counterMI = 0;

		// load config.xml			
		$xmldocument = DOMDocument::load(Common::$CONFIG_PATH);
		$xmldocument->formatOutput = true;
		$xmldocument->preserveWhiteSpace = false;
		$rootNode = $xmldocument->documentElement;

		$domxpath = new DOMXPath($xmldocument);
		$com1 = $domxpath -> query("//System/Ports/Port[@ID='COM1']",$rootNode)->item(0);
		$com1_Mode = "";
		$com1_BaudRate = "";
		$com1_DataBit = "";
		$com1_Parity = "";
		$com1_StopBit = "";
		$com1_FlowControl = "";

		$com2 = $domxpath -> query("//System/Ports/Port[@ID='COM2']",$rootNode)->item(0);
		$com2_Mode = "";
		$com2_BaudRate = "";
		$com2_DataBit = "";
		$com2_Parity = "";
		$com2_StopBit = "";
		$com2_FlowControl = "";

		// Clean Device Node
		$DevicesNode = $domxpath -> query("//System/Modbus/Devices",$rootNode)->item(0);
		while ($DevicesNode->hasChildNodes())
		{
			$childNode = $DevicesNode->childNodes;
			$DevicesNode->removeChild($childNode->item(0));
		}

		// Clean Mapping
		$MappingNodeBO = $domxpath -> query("//System/BACnetModbusMapping/BINARYOUTPUT",$rootNode)->item(0);
		$sysNodeBO = $MappingNodeBO->parentNode;
		$sysNodeBO->removeChild($MappingNodeBO);
		$MappingNodeBO = $xmldocument->createElement("BINARYOUTPUT");
		$sysNodeBO -> appendChild($MappingNodeBO);
		
		$MappingNodeBI = $domxpath -> query("//System/BACnetModbusMapping/BINARYINPUT",$rootNode)->item(0);
		$sysNodeBI = $MappingNodeBI->parentNode;
		$sysNodeBI->removeChild($MappingNodeBI);
		$MappingNodeBI = $xmldocument->createElement("BINARYINPUT");
		$sysNodeBI -> appendChild($MappingNodeBI);
		
		$MappingNodeBV = $domxpath -> query("//System/BACnetModbusMapping/BINARYVALUE",$rootNode)->item(0);
		$sysNodeBV = $MappingNodeBV->parentNode;
		$sysNodeBV->removeChild($MappingNodeBV);
		$MappingNodeBV = $xmldocument->createElement("BINARYVALUE");
		$sysNodeBV -> appendChild($MappingNodeBV);
		
		$MappingNodeAI = $domxpath -> query("//System/BACnetModbusMapping/ANALOGINPUT",$rootNode)->item(0);
		$sysNodeAI = $MappingNodeAI->parentNode;
		$sysNodeAI->removeChild($MappingNodeAI);
		$MappingNodeAI = $xmldocument->createElement("ANALOGINPUT");
		$sysNodeAI -> appendChild($MappingNodeAI);
		
		$MappingNodeAO = $domxpath -> query("//System/BACnetModbusMapping/ANALOGOUTPUT",$rootNode)->item(0);
		$sysNodeAO = $MappingNodeAO->parentNode;
		$sysNodeAO->removeChild($MappingNodeAO);
		$MappingNodeAO = $xmldocument->createElement("ANALOGOUTPUT");
		$sysNodeAO -> appendChild($MappingNodeAO);
		
		$MappingNodeAV = $domxpath -> query("//System/BACnetModbusMapping/ANALOGVALUE",$rootNode)->item(0);
		$sysNodeAV = $MappingNodeAV->parentNode;
		$sysNodeAV->removeChild($MappingNodeAV);
		$MappingNodeAV = $xmldocument->createElement("ANALOGVALUE");
		$sysNodeAV -> appendChild($MappingNodeAV);

		// read header
		fgets($file);
	
		while(!feof($file))
		{
			$data = fgets($file);
	
			list($device,$type,$tcpAddress,$tcpPort,$tcpUnit,$serialPort,$mode,$baudRate,$dataBit,$parity,$stopBit,
			$flowControl,$deviceID,$point,$address,$count,$index,$modbusType,$typedef,$sampling,$timeout,$scalefactor,
			$intercept,$low,$hi,$write,$objectName,$covIncrement,$covPeriod,$unit,$relinquish,$polarity,
			$description,$mappingtype) = explode(',', $data);
	
			if ($device == "")
			{
				continue;
			}
	
			if ($mappingtype == "")
			{
				continue;
			}
	
			$index= strtoupper($index);
			$type = strtoupper($type);
			$serialPort = strtoupper($serialPort);
			$mode = strtoupper($mode);
			$parity = strtoupper($parity);
			$flowControl = strtoupper($flowControl);
			$modbusType = strtoupper($modbusType);
			$typedef = strtoupper($typedef);
			$write = strtoupper($write);
			$mappingtype = strtoupper($mappingtype);
			$mappingtype = str_replace("\n", "", $mappingtype);
			$mappingtype = str_replace("\r", "", $mappingtype);
	
			$tempList = $domxpath -> query("//System/BACnetModbusMapping/Item[@Device='".$device."'][@Point='".$point."'][@Index='".$index."']",$rootNode);
	
			if ($tempList -> length > 0)
			{
				echo("ERROR: Point '".$point."' Index '".$index."' of Device '".$device."' already mapped\n");
				fclose($file);
				return;
			}
	
			// validate setting
			if ( strcmp($type,"RTU")==0 )
			{
				if ((strcmp($baudRate,"110") != 0) && (strcmp($baudRate,"300") != 0)&&
					(strcmp($baudRate,"1200") != 0) && (strcmp($baudRate,"2400") != 0)&&
					(strcmp($baudRate,"4800") != 0) && (strcmp($baudRate,"9600") != 0) && 
					(strcmp($baudRate,"19200") != 0) && (strcmp($baudRate,"38400") != 0) &&
					(strcmp($baudRate,"57600") != 0) && (strcmp($baudRate,"115200") != 0) &&
					(strcmp($baudRate,"230400") != 0) && (strcmp($baudRate,"460800") != 0) && 
					(strcmp($baudRate,"921600") != 0))
				{
					echo("ERROR: Unknown BaudRate\n");
					fclose($file); 
					return;
				}
	
				if ((strcmp($dataBit,"6") != 0) && (strcmp($dataBit,"7") != 0)&& (strcmp($dataBit,"8") != 0))
				{
					echo("ERROR: Unknown DataBit\n");
					fclose($file); 
					return;
				} 
	
				if ((strcmp($parity,"NONE") != 0) && (strcmp($parity,"EVEN") != 0)&& (strcmp($parity,"ODD") != 0))
				{
					echo("ERROR: Unknown Parity\n");
					fclose($file); 
					return;
				}
				
				if ((strcmp($stopBit,"1") != 0) && (strcmp($stopBit,"2") != 0))
				{
					echo("ERROR: Unknown StopBit\n");
					fclose($file); 
					return;
				}
				
				if ((strcmp($flowControl,"NONE") != 0) && (strcmp($flowControl,"HARDWARE") != 0)&& (strcmp($flowControl,"XON/XOFF") != 0))
				{
					echo("ERROR: Unknown FlowControl\n");
					fclose($file); 
					return;
				}
			}else if ( strcmp($type,"TCP")==0 )
			{
				if (validateIpAddress($tcpAddress) ==  false)
				{
					echo("Error: Invalid TCP IP Address\n");
					return;
				}
	
				if (is_numeric($tcpPort) ==  false)
				{
					echo("Error: Invalid TCP port\n");
					return;
				}
	
				if (is_numeric($tcpUnit) ==  false)
				{
					echo("Error: Invalid TCP unit\n");
					return;
				}
			}else
			{
				echo("ERROR: Unknown Modbus Type\n");
				fclose($file); 
				return;
			}
	
			// check whether device exist
			$tempList = $domxpath -> query("//System/Modbus/Devices/Device [@ID='".$device."']",$rootNode);
	
			if ($tempList -> length == 0)
			{
				$tempDeviceNode = $xmldocument -> createElement("Device");
				$tempDeviceNode->setAttribute( "ID" , $device);
				$tempDeviceNode->setAttribute( "Type" , $type);
				$tempDeviceNode->setAttribute( "Port" , $serialPort);
				if (strcmp($type,"RTU")==0)
				{
					if (strcmp($serialPort,"COM1")==0)
					{
						// check whether com1 is already used
						if ($com1_Mode != "")
						{
							// check setting
							if (strcmp($mode,$com1_Mode)!=0)
							{
								echo("ERROR: COM1 MODE Not Identical.\n");
								fclose($file); 
								return;
							}
	
							if (strcmp($baudRate,$com1_BaudRate)!=0)
							{
								echo("ERROR: COM1 BaudRate Not Identical.\n");
								fclose($file); 
								return;
							}
	
							if (strcmp($dataBit,$com1_DataBit)!=0)
							{
								echo("ERROR: COM1 DataBit Not Identical.\n");
								fclose($file);
								return;
							}
	
							if (strcmp($parity,$com1_Parity)!=0)
							{
								echo("ERROR: COM1 Parity Not Identical.\n");
								fclose($file);
								return;
							}
	
							if (strcmp($stopBit,$com1_StopBit)!=0)
							{
								echo("ERROR: COM1 StopBit Not Identical.\n");
								fclose($file);
								return;
							}
	
							if (strcmp($flowControl,$com1_FlowControl)!=0)
							{
								echo("ERROR: COM1 Flowcontrol Not Identical.\n");
								fclose($file);
								return;
							}
	
						}else{
							$com1_Mode = $mode;
							$com1_BaudRate = $baudRate;
							$com1_DataBit = $dataBit;
							$com1_Parity = $parity;
							$com1_StopBit = $stopBit;
							$com1_FlowControl = $flowControl;
						}
	
					}else if (strcmp($serialPort,"COM2")!=0)
	
					{
	
						// check whether com2 is already used
	
						if ($com2_Mode != "")
	
						{
	
							if (strcmp($mode,$com2_Mode)!=0)
	
							{
	
								echo("ERROR: COM2 MODE Not Identical\n");
	
								fclose($file);
	
								return;
	
							}
	
							if (strcmp($baudRate,$com2_BaudRate)!=0)
	
							{
	
								echo("ERROR: COM2 BaudRate Not Identical\n");
	
								fclose($file);
	
								return;
	
							}
	
							if (strcmp($dataBit,$com2_DataBit)!=0)
	
							{
	
								echo("ERROR: COM2 DataBit Not Identical\n");
	
								fclose($file);
	
								return;
	
							}
	
							if (strcmp($parity,$com2_Parity)!=0)
	
							{
	
								echo("ERROR: COM2 Parity Not Identical\n");
	
								fclose($file);
	
								return;
	
							}
	
							if (strcmp($stopBit,$com2_StopBit)!=0)
	
							{
	
								echo("ERROR: COM2 StopBit Not Identical\n");
	
								fclose($file);
	
								return;
	
							}
	
							if (strcmp($flowControl,$com2_FlowControl)!=0)
	
							{
	
								echo("ERROR: COM2 Flowcontrol Not Identical\n");
	
								fclose($file);
	
								return;
	
							}
	
						}else
	
						{
	
							$com2_Mode = $mode;
	
							$com2_BaudRate = $baudRate;
	
							$com2_DataBit = $dataBit;
	
							$com2_Parity = $parity;
	
							$com2_StopBit = $stopBit;
	
							$com2_FlowControl = $flowControl;
	
						}
	
					}else
	
					{
	
						echo("ERROR:".$serialPort." Does not Exist\n");
	
						fclose($file);
	
						return;
	
					}
	
					$tempDeviceNode->setAttribute( "DeviceID" , $deviceID);
	
				}else if(strcmp($type,"TCP")==0)
	
				{
	
					$tempDeviceNode->setAttribute( "Address" , $tcpAddress);
	
					$tempDeviceNode->setAttribute( "Port" , $tcpPort);
	
					$tempDeviceNode->setAttribute( "Unit" , $tcpUnit);
	
				}
	
				// Add Device
	
				$DevicesNode-> appendChild($tempDeviceNode);
	
				// Create Point List
	
				$tempNode = $xmldocument->createElement("Points");
	
				$tempDeviceNode -> appendChild($tempNode);
	
				// Add Point
	
				$tempPointNode = $xmldocument -> createElement("Point");
	
				$tempPointNode->setAttribute("ID",$point);
	
				$tempPointNode->setAttribute("Address",$address);
	
				$tempPointNode->setAttribute("Count",$count);
	
				$tempPointNode->setAttribute("TypeDef",$typedef);
	
				$tempPointNode->setAttribute("Sampling",$sampling);
	
				$tempPointNode->setAttribute("TimeOut",$timeout);
	
				$tempPointNode->setAttribute("ScaleFactor",$scalefactor);
	
				$tempPointNode->setAttribute("Intercept",$intercept);
	
				$tempPointNode->setAttribute("Low",$low);
	
				$tempPointNode->setAttribute("Hi",$hi);
	
				$tempPointNode->setAttribute("Write",$write);
	
				$tempPointNode->setAttribute("Type",$modbusType);
	
				//$tempPointNode->setAttribute("Description",$description);
	
				// Add Mapping
	
				$tempNode-> appendChild($tempPointNode);
				$tempMapNode = $xmldocument -> createElement("Item");
				$tempMapNode->setAttribute( "Type" , $mappingtype);
				$tempMapNode->setAttribute( "Device" , $device);
				$tempMapNode->setAttribute( "Point" , $point);
				$tempMapNode->setAttribute( "Index" , $index);
	
				if (strpos($mappingtype,"ANALOGVALUE")!== false){
				
					$tempMapNode->setAttribute( "ToKey" , "AV".$counterAV."present-value");
					 global $counterAV;
					++$counterAV;
					
					$tempMapNode->setAttribute( "ObjectName" , $objectName);
					$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
					$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
					$tempMapNode->setAttribute( "Unit" , $unit);
					$tempMapNode->setAttribute( "Relinquish" , $relinquish);
					$tempMapNode->setAttribute( "Polarity" , $polarity);
					$tempMapNode->setAttribute( "Description" , $description);
	
					$MappingNodeAV-> appendChild($tempMapNode);
					
				}else if (strpos($mappingtype,"ANALOGOUTPUT")!== false){
	
					$tempMapNode->setAttribute( "ToKey" , "AO".$counterAO."present-value");
					 global $counterAO;
					++$counterAO;
					
					$tempMapNode->setAttribute( "ObjectName" , $objectName);
					$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
					$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
					$tempMapNode->setAttribute( "Unit" , $unit);
					$tempMapNode->setAttribute( "Relinquish" , $relinquish);
					$tempMapNode->setAttribute( "Polarity" , $polarity);
					$tempMapNode->setAttribute( "Description" , $description);
	
					$MappingNodeAO-> appendChild($tempMapNode);
	
				}else if (strpos($mappingtype,"ANALOGINPUT")!== false){
	
					$tempMapNode->setAttribute( "ToKey" , "AI".$counterAI."present-value");
					 global $counterAI;
					++$counterAI;
					
					$tempMapNode->setAttribute( "ObjectName" , $objectName);
					$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
					$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
					$tempMapNode->setAttribute( "Unit" , $unit);
					$tempMapNode->setAttribute( "Relinquish" , $relinquish);
					$tempMapNode->setAttribute( "Polarity" , $polarity);
					$tempMapNode->setAttribute( "Description" , $description);
	
					$MappingNodeAI-> appendChild($tempMapNode);
	
				}else if (strpos($mappingtype,"BINARYVALUE")!== false){
	
					$tempMapNode->setAttribute( "ToKey" , "BV".$counterBV."present-value");
					global $counterBV;
					++$counterBV;
					
					$tempMapNode->setAttribute( "ObjectName" , $objectName);
					$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
					$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
					$tempMapNode->setAttribute( "Unit" , $unit);
					$tempMapNode->setAttribute( "Relinquish" , $relinquish);
					$tempMapNode->setAttribute( "Polarity" , $polarity);
					$tempMapNode->setAttribute( "Description" , $description);
	
					$MappingNodeBV-> appendChild($tempMapNode);
	
				}else if (strpos($mappingtype,"BINARYINPUT")!== false){
	
					$tempMapNode->setAttribute( "ToKey" , "BI".$counterBI."present-value");
					global $counterBI;
					++$counterBI;
					
					$tempMapNode->setAttribute( "ObjectName" , $objectName);
					$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
					$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
					$tempMapNode->setAttribute( "Unit" , $unit);
					$tempMapNode->setAttribute( "Relinquish" , $relinquish);
					$tempMapNode->setAttribute( "Polarity" , $polarity);
					$tempMapNode->setAttribute( "Description" , $description);
	
					$MappingNodeBI-> appendChild($tempMapNode);
	
				}else if (strpos($mappingtype,"BINARYOUTPUT")!== false){
	
					$tempMapNode->setAttribute( "ToKey" , "BO".$counterBO."present-value");
					global $counterBO;
					++$counterBO;
					
					$tempMapNode->setAttribute( "ObjectName" , $objectName);
					$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
					$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
					$tempMapNode->setAttribute( "Unit" , $unit);
					$tempMapNode->setAttribute( "Relinquish" , $relinquish);
					$tempMapNode->setAttribute( "Polarity" , $polarity);
					$tempMapNode->setAttribute( "Description" , $description);
	
					$MappingNodeBO-> appendChild($tempMapNode);
	
				}else if (strpos($mappingtype,"MULTISTATEVALUE")!== false){
	
					$tempMapNode->setAttribute( "ToKey" , "MSV".$counterMV."present-value");
					global $counterMV;
					++$counterMV;
	
				}else if (strpos($mappingtype,"MULTISTATEINPUT")!== false){
	
					$tempMapNode->setAttribute( "ToKey" , "MSI".$counterMI."present-value");
					global $counterMI;
					++$counterMI;
	
				}else if (strpos($mappingtype,"MULTISTATEOUTPUT")!== false){
	
					$tempMapNode->setAttribute( "ToKey" , "MSO".$counterMO."present-value");
					global $counterMO;
					++$counterMO;
	
				}else
				{
					echo ("'".stripos($mappingtype,"ANALOGOUTPUT")."'</br>");
					echo("ERROR:Unknown BACnet Type ".$mappingtype);
					fclose($file);
					return;
				}
	
				/*$tempMapNode->setAttribute( "ObjectName" , $objectName);
				$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
				$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
				$tempMapNode->setAttribute( "Unit" , $unit);
				$tempMapNode->setAttribute( "Relinquish" , $relinquish);
				$tempMapNode->setAttribute( "Polarity" , $polarity);
				$tempMapNode->setAttribute( "Description" , $description);
	
				$MappingNode-> appendChild($tempMapNode);*/
	
			}else{
	
				// Device Exist Check Setting
	
				$tempDeviceNode = $tempList->item(0);
	
				
	
				$tempType = $tempDeviceNode-> getAttribute("Type");
	
				if (strcmp($tempType,$type)!=0)
	
				{
	
					echo("ERROR: Device Type does not match current device\n");
	
					fclose($file);
	
					return;
	
				}
	
				
	
				if (strcmp($type,"RTU")==0)
	
				{
	
					$tempPort = $tempDeviceNode-> getAttribute("Port");
	
					if (strcmp($tempPort,$serialPort)!=0)
	
					{
	
						echo("ERROR: Device Port does not match current device\n");
	
						fclose($file);
	
						return;
	
					}
	
					
	
					if (strcmp($serialPort,"COM1")==0)
	
					{
	
						if (strcmp($mode,$com1_Mode)!=0)
	
						{
	
							echo("ERROR: COM1 MODE Not Identical.\n");
	
							fclose($file); 
	
							return;
	
						}
	
						
	
						if (strcmp($baudRate,$com1_BaudRate)!=0)
	
						{
	
							echo("ERROR: COM1 BaudRate Not Identical.\n");
	
							fclose($file); 
	
							return;
	
						}
	
						
	
						if (strcmp($dataBit,$com1_DataBit)!=0)
	
						{
	
							echo("ERROR: COM1 DataBit Not Identical.\n");
	
							fclose($file);
	
							return;
	
						}
	
						
	
						if (strcmp($parity,$com1_Parity)!=0)
	
						{
	
							echo("ERROR: COM1 Parity Not Identical.\n");
	
							fclose($file);
	
							return;
	
						}
	
						
	
						if (strcmp($stopBit,$com1_StopBit)!=0)
	
						{
	
							echo("ERROR: COM1 StopBit Not Identical.\n");
	
							fclose($file);
	
							return;
	
						}
	
						
	
						if (strcmp($flowControl,$com1_FlowControl)!=0)
	
						{
	
							echo("ERROR: COM1 Flowcontrol Not Identical.\n");
	
							fclose($file);
	
							return;
	
						}
	
						
	
					}else if (strcmp($serialPort,"COM2")==0)
	
					{
	
						if (strcmp($mode,$com2_Mode)!=0)
	
						{
	
							echo("ERROR: COM2 MODE Not Identical\n");
	
							fclose($file);
	
							return;
	
						}
	
						if (strcmp($baudRate,$com2_BaudRate)!=0)
	
						{
	
							echo("ERROR: COM2 BaudRate Not Identical\n");
	
							fclose($file);
	
							return;
	
						}
	
						if (strcmp($dataBit,$com2_DataBit)!=0)
	
						{
	
							echo("ERROR: COM2 DataBit Not Identical\n");
	
							fclose($file);
	
							return;
	
						}
	
						if (strcmp($parity,$com2_Parity)!=0)
	
						{
	
							echo("ERROR: COM2 Parity Not Identical\n");
	
							fclose($file);
	
							return;
	
						}
	
						if (strcmp($stopBit,$com2_StopBit)!=0)
	
						{
	
							echo("ERROR: COM2 StopBit Not Identical\n");
	
							fclose($file);
	
							return;
	
						}
	
						if (strcmp($flowControl,$com2_FlowControl)!=0)
	
						{
	
							echo("ERROR: COM2 Flowcontrol Not Identical\n");
	
							fclose($file);
	
							return;
	
						}
	
					}else
	
					{
	
						echo("ERROR:".$serialPort." Does not Exist\n");
	
						fclose($file);
	
						return;
	
					}
	
					
	
					if (strcmp($deviceID,$tempDeviceNode-> getAttribute("DeviceID"))!=0)
	
					{
	
						echo("ERROR: DeviceID Does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
				
	
				}else if(strcmp($type,"TCP")==0)
	
				{
	
					if (strcmp($tcpAddress,$tempDeviceNode-> getAttribute("Address"))!=0)
	
					{
	
						echo("ERROR: TCP Addres does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($tcpPort,$tempDeviceNode-> getAttribute("Port"))!=0)
	
					{
	
						echo("ERROR: TCP Port does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($tcpUnit,$tempDeviceNode-> getAttribute("Unit"))!=0)
	
					{
	
						echo("ERROR: TCP Unit does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
				} else
	
				{
	
					echo("ERROR: Unknow Device Type\n");
	
					return;
	
				}
	
				// Check Point Exist
	
				$tempList = $domxpath -> query("Points/Point[@ID='".$point."']",$tempDeviceNode);
	
				if ($tempList -> length == 0)
	
				{
	
					// Point Not Exist, add the point
	
					$tempPointNode = $xmldocument -> createElement("Point");
	
					$tempPointNode->setAttribute("ID",$point);
	
					$tempPointNode->setAttribute("Address",$address);
	
					$tempPointNode->setAttribute("Count",$count);
	
					$tempPointNode->setAttribute("TypeDef",$typedef);
	
					$tempPointNode->setAttribute("Sampling",$sampling);
	
					$tempPointNode->setAttribute("TimeOut",$timeout);
	
					$tempPointNode->setAttribute("ScaleFactor",$scalefactor);
	
					$tempPointNode->setAttribute("Intercept",$intercept);
	
					$tempPointNode->setAttribute("Low",$low);
	
					$tempPointNode->setAttribute("Hi",$hi);
	
					$tempPointNode->setAttribute("Write",$write);
	
					$tempPointNode->setAttribute("Type",$modbusType);
	
					//$tempPointNode->setAttribute("Description",$description);
	
	
	
					$tempList = $domxpath -> query("Points",$tempDeviceNode);
	
					$tempList->item(0)->appendChild($tempPointNode);
	
	
	
					$tempMapNode = $xmldocument -> createElement("Item");
	
					$tempMapNode->setAttribute( "Type" , $mappingtype);
	
					$tempMapNode->setAttribute( "Device" , $device);
	
					$tempMapNode->setAttribute( "Point" , $point);
	
					$tempMapNode->setAttribute( "Index" , $index);
	
					if (strcmp($mappingtype,"ANALOGVALUE")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "AV".$counterAV."present-value");
						global $counterAV;
						++$counterAV;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
	
						$MappingNodeAV-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"ANALOGOUTPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "AO".$counterAO."present-value");
						global $counterAO;
						++$counterAO;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
	
						$MappingNodeAO-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"ANALOGINPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "AI".$counterAI."present-value");
						global $counterAI;
						++$counterAI;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
	
						$MappingNodeAI-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"BINARYVALUE")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "BV".$counterBV."present-value");
						global $counterBV;
						++$counterBV;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
	
						$MappingNodeBV-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"BINARYINPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "BI".$counterBI."present-value");
						global $counterBI;
						++$counterBI;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
	
						$MappingNodeBI-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"BINARYOUTPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "BO".$counterBO."present-value");
						global $counterBO;
						++$counterBO;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
	
						$MappingNodeBO-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"MULTISTATEVALUE")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "MSV".$counterMV."present-value");
						global $counterMV;
						++$counterMV;
	
					}else if (strcmp($mappingtype,"MULTISTATEINPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "MSI".$counterMI."present-value");
						global $counterMI;
						++$counterMI;
	
					}else if (strcmp($mappingtype,"MULTISTATEOUTPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "MSO".$counterMO."present-value");
						global $counterMO;
						++$counterMO;
	
					}
	
					
	
					/*$tempMapNode->setAttribute( "ObjectName" , $objectName);
					$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
					$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
					$tempMapNode->setAttribute( "Unit" , $unit);
					$tempMapNode->setAttribute( "Relinquish" , $relinquish);
					$tempMapNode->setAttribute( "Polarity" , $polarity);
					$tempMapNode->setAttribute( "Description" , $description);
	
					$MappingNode-> appendChild($tempMapNode);*/
	
					
	
				}else{
	
					// Point Exist Check Point setting
	
					$tempPointNode = $tempList->item(0);
	
					if (strcmp($address,$tempPointNode-> getAttribute("Address"))!=0)
	
					{
	
						echo("ERROR: Point Address does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($count,$tempPointNode-> getAttribute("Count"))!=0)
	
					{
	
						echo("ERROR: Point Count does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($typedef,$tempPointNode-> getAttribute("TypeDef"))!=0)
	
					{
	
						echo("ERROR: Point TypeDef does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($sampling,$tempPointNode-> getAttribute("Sampling"))!=0)
	
					{
	
						echo("ERROR: Point Sampling does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($timeout,$tempPointNode-> getAttribute("TimeOut"))!=0)
	
					{
	
						echo("ERROR: Point TimeOut does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($scalefactor,$tempPointNode-> getAttribute("ScaleFactor"))!=0)
	
					{
	
						echo("ERROR: Point ScaleFactor does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($intercept,$tempPointNode-> getAttribute("Intercept"))!=0)
	
					{
	
						echo("ERROR: Point Intercept does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($low,$tempPointNode-> getAttribute("Low"))!=0)
	
					{
	
						echo("ERROR: Point Low does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($hi,$tempPointNode-> getAttribute("Hi"))!=0)
	
					{
	
						echo("ERROR: Point Hi does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($write,$tempPointNode-> getAttribute("Write"))!=0)
	
					{
	
						echo("ERROR: Point Write does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
					if (strcmp($modbusType,$tempPointNode-> getAttribute("Type"))!=0)
	
					{
	
						echo("ERROR: Point Type does not match\n");
	
						fclose($file);
	
						return;
	
					}
	
	//	  			if (strcmp($description,$tempPointNode-> getAttribute("Description"))!=0)
	
	//				{
	
	//					echo("ERROR: Point Description does not match\n");
	
	//					fclose($file);
	
	//					return;
	
	//				}
	
					// Add Mapping
	
					$tempMapNode = $xmldocument -> createElement("Item");
	
					$tempMapNode->setAttribute( "Type" , $mappingtype);
	
					$tempMapNode->setAttribute( "Device" , $device);
	
					$tempMapNode->setAttribute( "Point" , $point);
	
					$tempMapNode->setAttribute( "Index" , $index);
	
					if (strcmp($mappingtype,"ANALOGVALUE")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "AV".$counterAV."present-value");
						global $counterAV;
						++$counterAV;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
					
						$MappingNodeAV-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"ANALOGOUTPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "AO".$counterAO."present-value");
					global $counterAO;
						++$counterAO;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
					
						$MappingNodeAO-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"ANALOGINPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "AI".$counterAI."present-value");
						global $counterAI;
						++$counterAI;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
					
						$MappingNodeAI-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"BINARYVALUE")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "BV".$counterBV."present-value");
						global $counterBV;
						++$counterBV;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
					
						$MappingNodeBV-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"BINARYINPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "BI".$counterBI."present-value");
						global $counterBI;
						++$counterBI;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
					
						$MappingNodeBI-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"BINARYOUTPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "BO".$counterBO."present-value");
						global $counterBO;
						++$counterBO;
						
						$tempMapNode->setAttribute( "ObjectName" , $objectName);
						$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
						$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
						$tempMapNode->setAttribute( "Unit" , $unit);
						$tempMapNode->setAttribute( "Relinquish" , $relinquish);
						$tempMapNode->setAttribute( "Polarity" , $polarity);
						$tempMapNode->setAttribute( "Description" , $description);
					
						$MappingNodeBO-> appendChild($tempMapNode);
	
					}else if (strcmp($mappingtype,"MULTISTATEVALUE")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "MSV".$counterMV."present-value");
						global $counterMV;
						++$counterMV;
	
					}else if (strcmp($mappingtype,"MULTISTATEINPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "MSI".$counterMI."present-value");
						global $counterMI;
						++$counterMI;
	
					}else if (strcmp($mappingtype,"MULTISTATEOUTPUT")==0){
	
						$tempMapNode->setAttribute( "ToKey" , "MSO".$counterMO."present-value");
						global $counterMO;
						++$counterMO;
	
					}
	
					
	
					/*$tempMapNode->setAttribute( "ObjectName" , $objectName);
					$tempMapNode->setAttribute( "COVIncrement" , $covIncrement);
					$tempMapNode->setAttribute( "COVPeriod" , $covPeriod);
					$tempMapNode->setAttribute( "Unit" , $unit);
					$tempMapNode->setAttribute( "Relinquish" , $relinquish);
					$tempMapNode->setAttribute( "Polarity" , $polarity);
					$tempMapNode->setAttribute( "Description" , $description);
	
					$MappingNode-> appendChild($tempMapNode);*/
	
				}
	
			}
	
		}
	
		 // Update COM Setting
	
		if ($com1_Mode != "")
	
		{
	
			$com1->setAttribute( "Mode" , $com1_Mode);
	
			$com1->setAttribute( "BaudRate" , $com1_BaudRate);
	
			$com1->setAttribute( "DataBit" , $com1_DataBit);
	
			$com1->setAttribute( "Parity" , $com1_Parity);
	
			$com1->setAttribute( "StopBit" , $com1_StopBit);
	
			$com1->setAttribute( "FlowControl" , $com1_FlowControl);
	
		}
	
		if ($com2_Mode != "")
	
		{
	
			$com2->setAttribute( "Mode" , $com1_Mode);
	
			$com2->setAttribute( "BaudRate" , $com1_BaudRate);
	
			$com2->setAttribute( "DataBit" , $com1_DataBit);
	
			$com2->setAttribute( "Parity" , $com1_Parity);
	
			$com2->setAttribute( "StopBit" , $com1_StopBit);
	
			$com2->setAttribute( "FlowControl" , $com1_FlowControl);
	
		}
	
		
	
		  // Update Current BACnet Object Count
	
		  $dataList = $domxpath -> query("//System/BACnetModbusMapping/ANALOGVALUE/Item[ANALOGVALUE]",$rootNode);
	
		  $tempList = $domxpath -> query("//System/BACnet/Objects/AnalogValue/InstanceNumber",$rootNode);          
	
		  if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("AnalogValue");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterAV;
			$tmpInstanceNode->nodeValue =$counterAV;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
	
		  
	
		  $dataList = $domxpath -> query("//System/BACnetModbusMapping/ANALOGOUTPUT/Item[@Type='ANALOGOUTPUT']",$rootNode);
	
		  $tempList = $domxpath -> query("//System/BACnet/Objects/AnalogOutput/InstanceNumber",$rootNode);
	
		  if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("AnalogOutput");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterAO;
			$tmpInstanceNode->nodeValue =$counterAO;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
	
		   
	
		  $dataList = $domxpath -> query("//System/BACnetModbusMapping/ANALOGINPUT/Item[@Type='ANALOGINPUT']",$rootNode);
	
		  $tempList = $domxpath -> query("//System/BACnet/Objects/AnalogInput/InstanceNumber",$rootNode);
	
		  if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("AnalogInput");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterAI;
			$tmpInstanceNode->nodeValue =$counterAI;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
	
	  
	
		$dataList = $domxpath -> query("//System/BACnetModbusMapping/BINARYINPUT/Item[@Type='BINARYINPUT']",$rootNode);
	
		$tempList = $domxpath -> query("//System/BACnet/Objects/BinaryInput/InstanceNumber",$rootNode);
	
		 if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("BinaryInput");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterBI;
			$tmpInstanceNode->nodeValue =$counterBI;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
	
	  
	
		 $dataList = $domxpath -> query("//System/BACnetModbusMapping/BINARYOUTPUT/Item[@Type='BINARYOUTPUT']",$rootNode);
	
		 $tempList = $domxpath -> query("//System/BACnet/Objects/BinaryOutput/InstanceNumber",$rootNode);
	
		 if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("BinaryOutput");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterBO;
			$tmpInstanceNode->nodeValue =$counterBO;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
	
	  
	
		 $dataList = $domxpath -> query("//System/BACnetModbusMapping/BINARYVALUE/Item[@Type='BINARYVALUE']",$rootNode);
	
		 $tempList = $domxpath -> query("//System/BACnet/Objects/BinaryValue/InstanceNumber",$rootNode);
	
		 if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("BinaryValue");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterBV;
			$tmpInstanceNode->nodeValue =$counterBV;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
	
		
		$dataList = $domxpath -> query("//System/BACnetModbusMapping/MULTISTATEINPUT/Item[@Type='MULTISTATEINPUT']",$rootNode);
	
		$tempList = $domxpath -> query("//System/BACnet/Objects/MultiStateInput/InstanceNumber",$rootNode);
	
		 if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("MultiStateInput");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterMI;
			$tmpInstanceNode->nodeValue =$counterMI;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
	
	  
	
		 $dataList = $domxpath -> query("//System/BACnetModbusMapping/MULTISTATEOUTPUT/Item[@Type='MULTISTATEOUTPUT']",$rootNode);
	
		 $tempList = $domxpath -> query("//System/BACnet/Objects/MultiStateOutput/InstanceNumber",$rootNode);
	
		 if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("MultiStateOutput");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterMO;
			$tmpInstanceNode->nodeValue =$counterMO;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
	
	  
	
		 $dataList = $domxpath -> query("//System/BACnetModbusMapping/MULTISTATEVALUE/Item[@Type='MULTISTATEVALUE']",$rootNode);
	
		 $tempList = $domxpath -> query("//System/BACnet/Objects/MultiStateValue/InstanceNumber",$rootNode);
	
		 if ($tempList -> length <= 0)
	
		  {
	
			$tempObjectList = $domxpath -> query("//System/BACnet/Objects",$rootNode);
	
			$tempNode = $xmldocument -> createElement("MultiStateValue");  	 
	
			$tempObjectList->item(0)-> appendChild($tempNode);
	
			
	
			$tempMaxNode = $xmldocument -> createElement("Maximum");
	
			$tempMaxNode->nodeValue = $dataList->length;
	
			$tempNode-> appendChild($tempMaxNode);
	
			
	
			$tmpInstanceNode = $xmldocument -> createElement("InstanceNumber");
			global $counterMV;
			
			$tmpInstanceNode->nodeValue =$counterMV;
	
			$tempNode-> appendChild($tmpInstanceNode);
	
		  }else
	
		  {
	
			$tempList->item(0)->nodeValue =$dataList->length;
	
		  }
		  
	
	//  	$xmldocument->saveXML();
	
	//	$xmldocument->save(Common::$CONFIG_PATH);
	
		$xml = formatXmlString($xmldocument -> saveXML());
	
		
	
		$h = fopen(Common::$CONFIG_PATH, 'w');
	
		fwrite($h, $xml);
	
		fclose($h);
	
	
	
		fclose($file);
		
	}
	else
	{
		move_uploaded_file($_FILES["file"]["tmp_name"],"/firmware.tar");
	}

	header( 'location:../main.php' );

}



?>
