<?php
function loadXML($file)
{
	return DOMDocument::load($file);
}

function saveXML($domdocument,$path)
{
	$domdocument->formatOutput = true;
	$domdocument->saveXML();
	$domdocument->save($path);
}

function getRootNode($domdocument)
{
	
	return $domdocument->documentElement;
}
function getNodeContent($node)
{
	$value = $node->textContent;
	return $value;
}

function getNodeValue($node,$default)
{
	$value = $node->nodeValue;
	if($value =="")
	{
		return $default;
	}
	return $value;
}

function setNodeValue($node,$value)
{
	$node->nodeValue = $value;
}
function addChildNode($node,$name,$value)
{
	$domdocument = 	$node->ownerDocument;
	$child = $domdocument->createElement($name,$value);
	$node -> appendChild($child);
	return $child;
}
function removeChildNodes($node)
{
	while ($node->hasChildNodes()){
	  	$childNode = $node->childNodes;
	 	$node->removeChild($childNode->item(0));
	}
}

function removeNodes($node)
{
	$node->parentNode->removeChild($node);
}

function getNodeAttribute($node,$attribute,$default)
{

	$value = $node -> getAttribute($attribute);
	if ($value =="")
	{
		return $default;
	}
	return $value;
	
}

function setNodeAttribute($node,$attribute,$value)
{
	$node->setAttribute( $attribute , $value);
}

function getFirstNodeValue($node,$xpath,$default)
{
	$domdocument = 	$node->ownerDocument;
	$domxpath = new DOMXPath($domdocument);
	$nodeList = $domxpath -> query($xpath,$node);
	foreach ($nodeList as $xnode)
	{
		$value = $xnode->nodeValue;
		if($value =="")
		{
			return $default;
		}
		return $value;
	}
	return $default;
}

function getFirstNode($node,$xpath)
{
	$domdocument = 	$node->ownerDocument;
	$domxpath = new DOMXPath($domdocument);
	$nodeList = $domxpath -> query($xpath,$node);
	
	foreach ($nodeList as $node)
	{
		return $node;
	}
	return false;
}


function getAllNode($node,$xpath)
{
	$domdocument = 	$node->ownerDocument;
	$domxpath = new DOMXPath($domdocument);
	return $domxpath -> query($xpath,$node);
}

?>