#!/usr/bin/php
<?php

//== get or set interface information from "/etc/network/interfaces"
//[20160525] Kennis replaces broadcast ip from 192.168.255.255 to + 
class Network
{
	public $NetName="eth0";
	public $mode;
	public $address;
	public $netmask;
	public $gateway;
	public $broadcast;
	public $network;
	public $NETWORK_SETTING_PATH = "/etc/network/interfaces";

	function Network($Interfaces="eth0")
	{
		$this->NetName=$Interfaces;
		//$this->getNetConfig();
	}

	//-- get Net Interface information
	function getNetConfig()
	{
		$info = file_get_contents($this->NETWORK_SETTING_PATH);
		$info_array = explode("\n", $info);
		$IsObject = false;
		$this->mode = "DHCP";
		foreach($info_array as $index => $line)
		{
			$line = trim($line);
			//if($line[0] == '#') continue;
			if(!$IsObject)
			{
				if(strstr($line,"iface ".$this->NetName) === false)
					continue;
				else
					$IsObject=true;
			}
			if($IsObject && $line == "")//if get a empty line--> out object zone
			{
				break;
			}

			//into settings block
			//#iface eth0 inet static
			if(strpos($line, "iface eth0 inet static") !== false)
				$this->mode = "Static";

			if(($pos=strpos($line, "address")) !== false)
				$this->address = trim(substr($line, $pos+7));
			else if(($pos=strpos($line, "netmask")) !== false)
				$this->netmask = trim(substr($line, $pos+7));
			else if(($pos=strpos($line, "gateway")) !== false)
				$this->gateway = trim(substr($line, $pos+7));
			else if(($pos=strpos($line, "broadcast")) !== false)
				$this->broadcast = trim(substr($line, $pos+9));
			else if(($pos=strpos($line, "network")) !== false)
				$this->network = trim(substr($line, $pos+7));
		}
	}

	//-- set Net Interface information
	//	must have a empty line between 2 interfaces (configure ending flag)
	function setNetConfig()
	{
		$data = "auto lo\n". "iface lo inet loopback\n\n";
		$data = $data ."allow-hotplug eth0\n";
		if($this->mode == "DHCP")
		{
			$data = $data ."iface eth0 inet dhcp\n";
			$data = $data ."#" ."address " .$this->address ."\n";
			$data = $data ."#" ."netmask " .$this->netmask ."\n";
			$data = $data ."#" ."gateway " .$this->gateway ."\n";
			//[20160525] Kennis replaces broadcast ip from 192.168.255.255 to + 
			//$data = $data ."#" ."broadcast 192.168.255.255" ."\n";//$this->broadcast
			$data = $data ."#" ."broadcast +\n";
			$data = $data ."#" ."network 192.168.0.0" ."\n";		//$this->network
		}else
		{
			$data = $data ."iface eth0 inet static\n";
			$data = $data ."address " .$this->address ."\n";
			$data = $data ."netmask " .$this->netmask ."\n";
			if($this->gateway=="")
				$data = $data ."#" ."gateway " .$this->gateway ."\n";
			else
				$data = $data ."gateway " .$this->gateway ."\n";
			//$data = $data ."broadcast 192.168.255.255" ."\n";//$this->broadcast
            $ip_tmp = explode(".", $this->address);
            $mask_tmp = explode(".", $this->netmask);
            if($mask_tmp[0]=="255")
            	if($mask_tmp[1]=="255")
            		if($mask_tmp[2]=="255")
            			$this->broadcast = $ip_tmp[0].".".$ip_tmp[1].".".$ip_tmp[2].".255";
            		else
            			$this->broadcast = $ip_tmp[0].".".$ip_tmp[1].".255.255";
            	else
            		$this->broadcast = $ip_tmp[0].".255.255.255";
            	//$this->broadcast = $ip_tmp[0] ."." .$ip_tmp[1] .".255.255";
				
            //[20160525] Kennis replaces broadcast ip from 192.168.255.255 to + 	
            //$data = $data ."broadcast " .$this->broadcast ."\n";//$this->broadcast
			$data = $data ."broadcast +\n";
			$data = $data ."#" ."network 192.168.0.0" ."\n";		//$this->network
		}

		file_put_contents($this->NETWORK_SETTING_PATH, $data);
		return true;
	}

	function setBcastConfig()
	{
		$data = "auto lo\n". "iface lo inet loopback\n\n";
		$data = $data ."allow-hotplug eth0\n";
		if($this->mode == "DHCP")
		{
			$data = $data ."iface eth0 inet dhcp\n";
			$data = $data ."#" ."address " .$this->address ."\n";
			$data = $data ."#" ."netmask " .$this->netmask ."\n";
			$data = $data ."#" ."gateway " .$this->gateway ."\n";
			//[20160525] Kennis replaces broadcast ip from 192.168.255.255 to + 
			//$data = $data ."#" ."broadcast 192.168.255.255" ."\n";//$this->broadcast
			$data = $data ."#" ."broadcast +\n";
			$data = $data ."#" ."network 192.168.0.0" ."\n";		//$this->network
		}else
		{
			$data = $data ."iface eth0 inet static\n";
			$data = $data ."address " .$this->address ."\n";
			$data = $data ."netmask " .$this->netmask ."\n";
			if($this->gateway=="")
				$data = $data ."#" ."gateway " .$this->gateway ."\n";
			else
				$data = $data ."gateway " .$this->gateway ."\n";
			
			$data = $data ."broadcast +\n";
			$data = $data ."#" ."network 192.168.0.0" ."\n";		//$this->network
		}

		file_put_contents($this->NETWORK_SETTING_PATH, $data);
		return true;
	}
}

//[20160525] Kennis adds to fix /etc/init.d/S92fix_broadcast starts after firmware is running, 
// it leads users need reboot twice and then bacnetd gets the correct Bcast address.
$eth0 = new Network("eth0");
$eth0->getNetConfig();
$eth0->setBcastConfig();
while(1)
{
	//-- eth0 --
    $cmd = "ifconfig eth0";
    $info = shell_exec($cmd);
    //-- get Bcast Address
    $info = strstr($info, "Bcast:");
    strtok($info, ":");
    $bcast = strtok("\t ");
	
	$eth0->setBcastConfig();
	sleep(2);
	
	$info_new = shell_exec($cmd);
    //-- get Bcast Address
    $info_new = strstr($info_new, "Bcast:");
    strtok($info_new, ":");
	$bcast_new = strtok("\t ");
	
    if($bcast != $bcast_new)
    {
        echo "ifdown eth0\n";
        exec('ifdown eth0');
        sleep(2);
        echo "ifup eth0\n";
        exec('ifup eth0');
    }else
    {
        break;
    }
}

/* [20160525] commented by Kennis 
$eth0 = new Network("eth0");
$eth0->getNetConfig();
$eth0->setNetConfig();

while(1)
{
    //-- eth0 --
    $cmd = "ifconfig eth0";
    $info = shell_exec($cmd);
    //-- get IP
    $info = strstr($info, "Bcast:");
    strtok($info, ":");
    $bcast = strtok("\t ");

    if($bcast != $eth0->broadcast)
    {
        echo "ifdown eth0\n";
        exec('ifdown eth0');
        sleep(2);
        echo "ifup eth0\n";
        exec('ifup eth0');
    }else
    {
        break;
    }
}
*/
?>
